<template>
  <div class="serie-banner">
    <div class="trunk">
      <div class="serie-container">
        <div
          class="album-col"
          :style="{
            'background-image': `url(${bannerImage})`
          }"
        >
          <div class="overlay"></div>
          <div class="album-content">
            <SerieBreadcrumb
              :breadcrumbs="serie.breadcrumbs"
              :is-subscription="isSubscription"
            />
            <AppTitle class="text--white" :title="serie.name" />
            <StarRank :avgstar="serie.rate" :countnote="serie.rateAmount" />
            <a
              v-if="continueReadingAlbum"
              :href="continueReadingAlbum"
              @click.prevent="
                $utils.gtmEvent(
                  {
                    event: 'gtm.event',
                    EventCategory: 'Clic_Bouton',
                    EventAction: 'Lire',
                    EventLabel: `${serie.shelf.name}_${serie.name}`
                  },
                  continueReadingAlbum
                )
              "
            >
              <AppButton :theme="btnTheme" class="serie-btn">
                {{ $t('serie.read') }}
              </AppButton>
            </a>
          </div>
        </div>
        <div class="info-col">
          <div class="info-relative">
            <SerieSuperReader
              v-if="serie.SRreview && serie.SRreview.id"
              :serie="SRSerieData"
              :sr="serie.SRreview"
              class="super-reader"
            />
            <div class="actions">
              <div
                v-if="!serie.isfollowing"
                class="icon-text"
                @click="$emit('followSerie')"
              >
                <img :src="require('~/assets/images/ic-follow.svg')" />
                <div class="action-text" style="margin-right: 1rem">
                  {{ $t('followers.follow') }}
                </div>
              </div>
              <div
                v-if="serie.isfollowing"
                class="icon-text gray"
                @click="$emit('followSerie')"
              >
                <img :src="require('~/assets/images/ic_follow_selected.svg')" />
                <div class="action-text">{{ $t('followers.unfollow') }}</div>
              </div>
              <SerieFollowers :followers="followers" :connected="connected" />
              <div class="icon-text">
                <img
                  :src="require('~/assets/images/ic-share.svg')"
                  @click="toggleLinks = !toggleLinks"
                />
                <div class="remove-mobile share-item">
                  <div v-if="toggleLinks" class="share-links">
                    <img
                      :src="require('~/assets/images/ic-facebook.svg')"
                      @click="$emit('facebookShare')"
                    />
                    <a
                      href="https://twitter.com/share"
                      @click.prevent="
                        $utils.gtmEvent(
                          {
                            event: 'gtm.event',
                            EventCategory: 'Social',
                            EventAction: 'twitter',
                            EventLabel: `Partage_${serie.name}`
                          },
                          'https://twitter.com/share'
                        )
                      "
                    >
                      <img :src="require('~/assets/images/ic-twitter.svg')" />
                    </a>
                    <a
                      :href="`mailto:?Subject=${serie.name}&amp;Body=${currentSerieUrl}`"
                      @click.prevent="
                        $utils.gtmEvent(
                          {
                            event: 'gtm.event',
                            EventCategory: 'Social',
                            EventAction: 'mail',
                            EventLabel: `Partage_${serie.name}`
                          },
                          `mailto:?Subject=${serie.name}&amp;Body=${currentSerieUrl}`
                        )
                      "
                    >
                      <img :src="require('~/assets/images/ic-mail.svg')" />
                    </a>
                  </div>
                  <span
                    v-else
                    class="action-text"
                    @click="toggleLinks = !toggleLinks"
                  >
                    {{ $t('followers.share') }}
                  </span>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AppTitle from '~/components/ui/AppTitle'
import AppButton from '~/components/ui/AppButton'
import StarRank from '~/components/ui/StarRank'
import SerieFollowers from '~/components/Serie/SerieFollowers'
import SerieSuperReader from '~/components/Serie/SerieSuperReader'
import SerieBreadcrumb from '~/components/Serie/SerieBreadcrumb'

export default {
  components: {
    AppTitle,
    AppButton,
    StarRank,
    SerieFollowers,
    SerieSuperReader,
    SerieBreadcrumb
  },
  props: {
    serie: {
      type: Object,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: true
    },
    connected: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return { toggleLinks: false, currentSerieUrl: '' }
  },
  computed: {
    bannerImage() {
      let bannerImg

      // webtoon case
      if (+this.serie.shelf.id === 6) {
        bannerImg = `${this.$config.izneoUrl}/${this.$i18n.locale}/images/serie/${this.serie.id}.jpg?v=${this.serie.version}`
      } else if (this.isSubscription && this.serie.coverAbo) {
        bannerImg = `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.serie.coverAbo}.jpg?v=${this.serie.coverAboVersion}`
      } else {
        bannerImg = `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.serie.cover}.jpg?v=${this.serie.coverVersion}`
      }

      return bannerImg
    },
    btnTheme() {
      return this.isSubscription ? 'secondary' : ''
    },
    followers() {
      return !!this.serie.followers && this.serie.followers.users
        ? this.serie.followers.users
        : []
    },
    SRSerieData() {
      return {
        shelf: this.serie.shelf.slug,
        slug: this.serie.forUrl,
        genre: this.serie.genre.slug
      }
    },
    host() {
      return this.$config.izneoUrl
    },
    continueReadingAlbum() {
      if (!this.serie.continueReadingAlbum) return ''
      const albumUrl = this.$utils.aboArea()
        ? this.serie.continueReadingAlbum.urlAbo
        : this.serie.continueReadingAlbum.url

      return (
        `${this.host}${albumUrl}` +
        (this.currentSerieUrl ? `?exiturl=${this.currentSerieUrl}` : '')
      )
    }
  },

  mounted() {
    this.currentSerieUrl = window.location.href
  },

  head() {
    return {
      titleTemplate: this.serie.name
    }
  }
}
</script>

<style lang="scss">
.serie-banner {
  background: #272626;
}

.serie-container {
  min-height: 545px;
  display: flex;
  justify-content: space-between;

  .album-col {
    position: relative;
    flex: 2;
    padding: 2rem;
    background-repeat: no-repeat;
    background-size: cover;
    background-position: center;

    .overlay {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: rgba(0, 0, 0, 0.4);
    }

    .album-content {
      position: relative;
      height: 100%;

      .countnote {
        color: #fff;
      }

      .serie-title {
        font-size: 90px;
        margin-top: 3rem;
      }

      .serie-btn {
        position: absolute;
        bottom: 2rem;
        left: 0;
      }
    }
  }

  .info-col {
    flex: 3;
    padding-top: 4rem;
    padding-left: 4rem;
    padding-bottom: 3rem;
  }

  .info-relative {
    position: relative;
    height: 100%;

    .super-reader {
      padding-right: 6rem;
    }
  }

  .actions {
    position: absolute;
    bottom: 0;
    left: 0;
    flex: 2;
    width: 100%;

    color: #fff;
    display: flex;
    align-items: center;
    justify-content: flex-start;

    .icon-text {
      cursor: pointer;
      text-transform: uppercase;
      font-family: DINCond-Bold;
      font-weight: bold;
      font-size: 20px;
      height: 20px;
      display: flex;

      &.gray {
        color: #adadad;
      }

      img {
        display: inline-block;
        height: 100%;
        padding-right: 0.75rem;

        @media (max-width: 1259px) {
          min-width: 24px;
          padding-right: 0.2rem;
        }
      }

      .action-text {
        padding-top: 3px;
      }

      @media (max-width: 1259px) {
        .action-text {
          &.remove-mobile {
            display: none;
          }
        }
      }

      @media (max-width: 1024px) {
        .action-text {
          display: none;
        }
      }
    }
  }

  .share-item {
    display: flex;
    padding-top: 0;
    align-items: center;
    flex-wrap: nowrap;

    .action-text {
      width: 97px;
    }

    .share-links {
      display: flex;
      justify-content: space-between;

      img {
        height: 34px;
        width: 34px;
        padding-right: 0.25rem;
      }
    }
  }
}
</style>
